Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.validation.beanvalidation
Class MethodValidationPostProcessor

    java.lang.Object
      org.springframework.aop.framework.ProxyConfig
          org.springframework.validation.beanvalidation.MethodValidationPostProcessor

All Implemented Interfaces:
  java.io.Serializable, Aware, BeanClassLoaderAware, BeanPostProcessor, InitializingBean, Ordered

    public class MethodValidationPostProcessor

extends ProxyConfig
implements BeanPostProcessor, BeanClassLoaderAware, Ordered, InitializingBean

A convenient `BeanPostProcessor` implementation that delegates to a JSR-303 provider for performing method-level validation on annotated methods.

Applicable methods have JSR-303 constraint annotations on their parameters and/or on their return value (in the latter case specified at the method level, typically as inline annotation), e.g.:

     public @NotNull Object myValidMethod(@NotNull String arg1, @Max(10) int arg2)

Target classes with such annotated methods need to be annotated with Spring's `Validated` annotation at the type level, for their methods to be searched for inline constraint annotations. Validation groups can be specified through `@Validated` as well. By default, JSR-303 will validate against its default group only.

As of Spring 3.1, this functionality requires Hibernate Validator 4.2 or higher. In Spring 3.2, this class will autodetect a Bean Validation 1.1 compliant provider and automatically use the standard method validation support there (once available).

Since:
  3.1
Author:
  Juergen Hoeller
See Also:
  `MethodValidationInterceptor`, `MethodValidator`, Serialized Form

Field Summary

Fields inherited from interface org.springframework.core.Ordered
`HIGHEST_PRECEDENCE, LOWEST_PRECEDENCE`

Constructor Summary
`MethodValidationPostProcessor()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`int` | `getOrder()` Return the order value of this object, with a higher value meaning greater in terms of sorting.
`java.lang.Object` | `postProcessAfterInitialization(java.lang.Object bean, java.lang.String beanName)` Apply this BeanPostProcessor to the given new bean instance after any bean initialization callbacks (like InitializingBean's `afterPropertiesSet` or a custom init-method).
`java.lang.Object` | `postProcessBeforeInitialization(java.lang.Object bean, java.lang.String beanName)` Apply this BeanPostProcessor to the given new bean instance before any bean initialization callbacks (like InitializingBean's `afterPropertiesSet` or a custom init-method).
`void` | `setBeanClassLoader(java.lang.ClassLoader classLoader)` Callback that supplies the bean `class loader` to a bean instance.
`void` | `setValidatedAnnotationType(java.lang.Class<? extends java.lang.annotation.Annotation> validatedAnnotationType)` Set the 'validated' annotation type.
`void` | `setValidator(javax.validation.Validator validator)` Set the JSR-303 Validator to delegate to for validating methods.
`void` | `setValidatorFactory(javax.validation.ValidatorFactory validatorFactory)` Set the JSR-303 ValidatorFactory to delegate to for validating methods, using its default Validator.

Methods inherited from class org.springframework.aop.framework.ProxyConfig
`copyFrom, isExposeProxy, isFrozen, isOpaque, isOptimize, isProxyTargetClass, setExposeProxy, setFrozen, setOpaque, setOptimize, setProxyTargetClass, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### MethodValidationPostProcessor

    public MethodValidationPostProcessor()

Method Detail

### setValidatedAnnotationType

    public void setValidatedAnnotationType(java.lang.Class<? extends java.lang.annotation.Annotation> validatedAnnotationType)

  Set the 'validated' annotation type. The default validated annotation type is the `Validated` annotation.

  This setter property exists so that developers can provide their own (non-Spring-specific) annotation type to indicate that a class is supposed to be validated in the sense of applying method validation.

  Parameters:
    `validatedAnnotationType` - the desired annotation type

### setValidator

    public void setValidator(javax.validation.Validator validator)

  Set the JSR-303 Validator to delegate to for validating methods.

  Default is the default ValidatorFactory's default Validator.

### setValidatorFactory

    public void setValidatorFactory(javax.validation.ValidatorFactory validatorFactory)

  Set the JSR-303 ValidatorFactory to delegate to for validating methods, using its default Validator.

  Default is the default ValidatorFactory's default Validator.

  See Also:
    `ValidatorFactory.getValidator()`

### setBeanClassLoader

    public void setBeanClassLoader(java.lang.ClassLoader classLoader)

  Description copied from interface: `BeanClassLoaderAware`
  Callback that supplies the bean `class loader` to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean's` `InitializingBean.afterPropertiesSet()` method or a custom init-method.

  Specified by:
    `setBeanClassLoader` in interface `BeanClassLoaderAware`
  Parameters:
    `classLoader` - the owning class loader; may be `null` in which case a default `ClassLoader` must be used, for example the `ClassLoader` obtained via `ClassUtils.getDefaultClassLoader()`

### getOrder

    public int getOrder()

  Description copied from interface: `Ordered`
  Return the order value of this object, with a higher value meaning greater in terms of sorting.

  Normally starting with 0, with `Integer.MAX_VALUE` indicating the greatest value. Same order values will result in arbitrary positions for the affected objects.

  Higher values can be interpreted as lower priority. As a consequence, the object with the lowest value has highest priority (somewhat analogous to Servlet "load-on-startup" values).

  Specified by:
    `getOrder` in interface `Ordered`
  Returns:
    the order value

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### postProcessBeforeInitialization

    public java.lang.Object postProcessBeforeInitialization(java.lang.Object bean,
                                                            java.lang.String beanName)
                                                     throws BeansException

  Description copied from interface: `BeanPostProcessor`
  Apply this BeanPostProcessor to the given new bean instance before any bean initialization callbacks (like InitializingBean's `afterPropertiesSet` or a custom init-method). The bean will already be populated with property values. The returned bean instance may be a wrapper around the original.

  Specified by:
    `postProcessBeforeInitialization` in interface `BeanPostProcessor`
  Parameters:
    `bean` - the new bean instance
    `beanName` - the name of the bean
  Returns:
    the bean instance to use, either the original or a wrapped one; if `null`, no subsequent BeanPostProcessors will be invoked
  Throws:
    `BeansException` - in case of errors
  See Also:
    `InitializingBean.afterPropertiesSet()`

### postProcessAfterInitialization

    public java.lang.Object postProcessAfterInitialization(java.lang.Object bean,
                                                           java.lang.String beanName)
                                                    throws BeansException

  Description copied from interface: `BeanPostProcessor`
  Apply this BeanPostProcessor to the given new bean instance after any bean initialization callbacks (like InitializingBean's `afterPropertiesSet` or a custom init-method). The bean will already be populated with property values. The returned bean instance may be a wrapper around the original.

  In case of a FactoryBean, this callback will be invoked for both the FactoryBean instance and the objects created by the FactoryBean (as of Spring 2.0). The post-processor can decide whether to apply to either the FactoryBean or created objects or both through corresponding `bean instanceof FactoryBean` checks.

  This callback will also be invoked after a short-circuiting triggered by a `InstantiationAwareBeanPostProcessor.postProcessBeforeInstantiation(java.lang.Class, java.lang.String)` method, in contrast to all other BeanPostProcessor callbacks.

  Specified by:
    `postProcessAfterInitialization` in interface `BeanPostProcessor`
  Parameters:
    `bean` - the new bean instance
    `beanName` - the name of the bean
  Returns:
    the bean instance to use, either the original or a wrapped one; if `null`, no subsequent BeanPostProcessors will be invoked
  Throws:
    `BeansException` - in case of errors
  See Also:
    `InitializingBean.afterPropertiesSet()`, `FactoryBean`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD